public class Location
{
	
	private String[] components ;
	
	public Location(String[] components)
	{
		this.components = (String[])components.clone() ;
	}
	
	public int numComponents()
	{
		return components.length ;
	}
	
	public String getComponent(int i)
	{
		return components[i] ;
	}
	
	// this is a value object, so ...
	
	public int hashCode()
	{
		// use Roedy Green's generic hashCode ...
		int h = 17 ;
		for (int i = 0 ; i < components.length ; ++i)
			h = (h * 37) + components[i].hashCode() ;
		return h ;
	}
	
	public boolean equals(Object obj)
	{
		if (!(obj instanceof Location)) return false ;
		Location loc = (Location)obj ;
		if (components.length != loc.components.length) return false ;
		for (int i = 0 ; i < components.length ; ++i)
			if (!components[i].equals(loc.components[i])) return false ;
		return true ;
	}
	
}
