import java.util.Set ;
import java.util.SortedSet ;
import java.util.HashSet ;
import java.util.TreeSet ;
import java.util.List ;
import java.util.ArrayList ;
import java.util.Iterator ;
import java.util.Collections ;

public class Person
{
	
	private String id ;
	private String name ;
	private Location loc ;
	private Set interests ;
	private Set friends ;
	
	public Person(String id, String name, Location loc)
	{
		this.id = id ;
		this.name = name ;
		this.loc = loc ;
		interests = new HashSet() ;
		friends = new HashSet() ;
	}
	
	public String getId()
	{
		return id ;
	}
	
	public String getName()
	{
		return name ;
	}
	
	public void setName(String name)
	{
		this.name = name ;
	}
	
	public Location getLocation()
	{
		return loc ;
	}
	
	public void setLocation(Location loc)
	{
		this.loc = loc ;
	}
	
	public Set listInterests()
	{
		return Collections.unmodifiableSet(interests) ;
	}
	
	public boolean hasInterest(String interest)
	{
		return interests.contains(interest) ;
	}
	
	public void addInterest(String interest)
	{
		interests.add(interest) ;
	}
	
	public void removeInterest(String interest)
	{
		interests.remove(interest) ;
	}
	
	public Set listFriends()
	{
		return Collections.unmodifiableSet(friends) ;
	}
	
	public boolean hasFriend(Person person)
	{
		return friends.contains(person) ;
	}
	
	public void addFriend(Person person)
	{
		friends.add(person) ;
	}
	
	public void removeFriend(Person person)
	{
		friends.remove(person) ;
	}
	
	public List findRouteTo(Person p)
	{
		// single inkdrop algorithm
		// you are not expected to understand this
		class Route implements Comparable
		{
			public Route start ;
			public Person end ;
			public Route(Route start, Person end)
			{
				this.start = start ;
				this.end = end ;
			}
			public int length()
			{
				if (start == null) return 0 ;
				else return start.length() + 1 ;
			}
			public int compareTo(Object obj)
			{
				Route r = (Route)obj ;
				return this.length() - r.length() ;
			}
			public List toList()
			{
				List l = new ArrayList(length()) ;
				Route r = start ;
				while (r != null)
				{
					l.add(0, r.end) ;
					r = r.start ;
				}
				return l ;
			}
			public String toString()
			{
				if (start == null) return end.getId() ;
				else return start.toString() + " " + end.getId() ;
			}
		}
		SortedSet options = new TreeSet() ;
		Set routed = new HashSet() ;
		routed.add(this) ;
		Iterator friendsIt = friends.iterator() ;
		while (friendsIt.hasNext())
		{
			Person f = (Person)friendsIt.next() ;
			Route r = new Route(null, f) ;
			options.add(r) ;
			routed.add(f) ;
		}
		while (true)
		{
			if(options.isEmpty()) return null ;
			Route r = (Route)options.first() ;
			options.remove(r) ;
			Person q = r.end ;
			if (q == p) return r.toList() ;
			Iterator foafIt = q.friends.iterator() ;
			while (foafIt.hasNext())
			{
				Person f = (Person)foafIt.next() ;
				if (!routed.contains(f))
				{
					Route s = new Route(r, f) ;
					options.add(s) ;
					routed.add(f) ;
				}
			}
		}
	}
	
	public String toString()
	{
		return name + " <" + id + ">" ;
	}
	
}
